
/*
 * Zeroth version of a framework to get started.
 * A few ideas to take from this, but far too complicated
 * and not enough documentation.
 * First version to come when I got the time.
 *
 * Lionel Lemarie
 * hikey@playstation2-linux.com
 * 2002-07-01
 */

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <unistd.h>
#include <ps2gs.h>
#include <ps2dma.h>
#include <linux/ps2/dev.h>
#include "packet.h"
#include "ps2hik.h"
#include "loaders.h"
#include "log.h"
#include "vu0.h"


void init();
void deinit(int);
int  main(int argc, char *argv[]);
void state_menu();
void state_load();
void state_game();
void state_quit();

void (*game_frame)();
int loop_again=1;

struct {
	image_t ps2tux;
	image_t boom;
} game_data;

#include <ps2vpu.h>
#include <ps2vpufile.h>
#include <ps2gs.h>

int main(int argc, char **argv)
{
	if (!ps2hik_init(argc,argv)) { printf("Error initialising devices, exiting...\n"); return 1; }
	ps2hik_set_deinit(deinit);

	log_init("log.txt", LOG_TRUNC(1), LOG_SYNC(1));

	ps2hik_printf_resolution();

	init();

	game_frame=state_menu;

	while (loop_again)
	{
		ps2hik_lock();
		game_frame();
		ps2hik_unlock();
	}

	ps2hik_release(0);

	return 0;
}

void init()
{
	init_image(&game_data.ps2tux);
}

void deinit(int sig)
{
	printf("Deinitialising before quitting\n");
	free_image(&game_data.ps2tux);
	free_image(&game_data.boom);
}

void state_menu()
{
	game_frame=state_load;
}

void state_load()
{
	// Load PCX files
	load_image_pcx("ps2tux.pcx", &game_data.ps2tux);
	load_image_pcx("boom.pcx", &game_data.boom);

	// Get address for them in VRAM
	ps2hik_set_image_address(&game_data.ps2tux);
	ps2hik_set_image_address(&game_data.boom);

	game_frame=state_game;
}

void state_game()
{
	static u_int *base_ptr=NULL;
	int NLOOP=36;
	// Cube data
	float vert_data[36][4] = { { -50.00, 50.00, 50.00, 1.00, }, { 50.00, -50.00, 50.00, 1.00, }, { -50.00, -50.00, 50.00, 1.00, }, { 50.00, -50.00, 50.00, 1.00, }, { -50.00, 50.00, 50.00, 1.00, }, { 50.00, 50.00, 50.00, 1.00, }, { -50.00, 50.00, -50.00, 1.00, }, { 50.00, -50.00, -50.00, 1.00, }, { 50.00, 50.00, -50.00, 1.00, }, { 50.00, -50.00, -50.00, 1.00, }, { -50.00, 50.00, -50.00, 1.00, }, { -50.00, -50.00, -50.00, 1.00, }, { -50.00, 50.00, 50.00, 1.00, }, { 50.00, 50.00, -50.00, 1.00, }, { 50.00, 50.00, 50.00, 1.00, }, { 50.00, 50.00, -50.00, 1.00, }, { -50.00, 50.00, 50.00, 1.00, }, { -50.00, 50.00, -50.00, 1.00, }, { 50.00, 50.00, 50.00, 1.00, }, { 50.00, -50.00, -50.00, 1.00, }, { 50.00, -50.00, 50.00, 1.00, }, { 50.00, -50.00, -50.00, 1.00,}, { 50.00, 50.00, 50.00, 1.00,}, { 50.00, 50.00, -50.00, 1.00,}, { 50.00, -50.00, 50.00, 1.00,}, { -50.00, -50.00, -50.00, 1.00,}, { -50.00, -50.00, 50.00, 1.00,}, { -50.00, -50.00, -50.00, 1.00,}, { 50.00, -50.00, 50.00, 1.00,}, { 50.00, -50.00, -50.00, 1.00,}, { -50.00, -50.00, 50.00, 1.00,}, { -50.00, 50.00, -50.00, 1.00,}, { -50.00, 50.00, 50.00, 1.00,}, { -50.00, 50.00, -50.00, 1.00,}, { -50.00, -50.00, 50.00, 1.00,}, { -50.00, -50.00, -50.00, 1.00,}, };
	float norm_data[36][4] = { { 0.0,0.0,1.0,1.0,}, { 0.0,0.0,1.0,1.0,}, { 0.0,0.0,1.0,1.0,}, { 0.0,0.0,1.0,1.0,}, { 0.0,0.0,1.0,1.0,}, { 0.0,0.0,1.0,1.0,}, { 0.0,0.0,-1.0,1.0,}, { 0.0,0.0,-1.0,1.0,}, { 0.0,0.0,-1.0,1.0,}, { 0.0,0.0,-1.0,1.0,}, { 0.0,0.0,-1.0,1.0,}, { 0.0,0.0,-1.0,1.0,}, { 0.0,1.0,0.0,1.0,}, { 0.0,1.0,0.0,1.0,}, { 0.0,1.0,0.0,1.0,}, { 0.0,1.0,0.0,1.0,}, { 0.0,1.0,0.0,1.0,}, { 0.0,1.0,0.0,1.0,}, { 1.0,0.0,0.0,1.0,}, { 1.0,0.0,0.0,1.0,}, { 1.0,0.0,0.0,1.0,}, { 1.0,0.0,0.0,1.0,}, { 1.0,0.0,0.0,1.0,}, { 1.0,0.0,0.0,1.0,}, { 0.0,-1.0,0.0,1.0,}, { 0.0,-1.0,0.0,1.0,}, { 0.0,-1.0,0.0,1.0,}, { 0.0,-1.0,0.0,1.0,}, { 0.0,-1.0,0.0,1.0,}, { 0.0,-1.0,0.0,1.0,}, { -1.0,0.0,0.0,1.0,}, { -1.0,0.0,0.0,1.0,}, { -1.0,0.0,0.0,1.0,}, { -1.0,0.0,0.0,1.0,}, { -1.0,0.0,0.0,1.0,}, { -1.0,0.0,0.0,1.0}, };
	float color_data[36][4] = { { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, { 128.0,128.0,128.0,128.0,}, };
	float st_data[36][4] = { { 1.0f, 0.0f, 1.0f, 0.0f,}, { 0.0f, 1.0f, 1.0f, 0.0f,}, { 0.0f, 0.0f, 1.0f, 0.0f,}, { 0.0f, 1.0f, 1.0f, 0.0f,}, { 1.0f, 0.0f, 1.0f, 0.0f,}, { 1.0f, 1.0f, 1.0f, 0.0f,}, { 1.0f, 0.0f, 1.0f, 0.0f,}, { 0.0f, 1.0f, 1.0f, 0.0f,}, { 0.0f, 0.0f, 1.0f, 0.0f,}, { 0.0f, 1.0f, 1.0f, 0.0f,}, { 1.0f, 0.0f, 1.0f, 0.0f,}, { 1.0f, 1.0f, 1.0f, 0.0f,}, { 1.0f, 0.0f, 1.0f, 0.0f,}, { 0.0f, 1.0f, 1.0f, 0.0f,}, { 0.0f, 0.0f, 1.0f, 0.0f,}, { 0.0f, 1.0f, 1.0f, 0.0f,}, { 1.0f, 0.0f, 1.0f, 0.0f,}, { 1.0f, 1.0f, 1.0f, 0.0f,}, { 1.0f, 0.0f, 1.0f, 0.0f,}, { 0.0f, 1.0f, 1.0f, 0.0f,}, { 0.0f, 0.0f, 1.0f, 0.0f,}, { 0.0f, 1.0f, 1.0f, 0.0f,}, { 1.0f, 0.0f, 1.0f, 0.0f,}, { 1.0f, 1.0f, 1.0f, 0.0f,}, { 1.0f, 0.0f, 1.0f, 0.0f,}, { 0.0f, 1.0f, 1.0f, 0.0f,}, { 0.0f, 0.0f, 1.0f, 0.0f,}, { 0.0f, 1.0f, 1.0f, 0.0f,}, { 1.0f, 0.0f, 1.0f, 0.0f,}, { 1.0f, 1.0f, 1.0f, 0.0f,}, { 1.0f, 0.0f, 1.0f, 0.0f,}, { 0.0f, 1.0f, 1.0f, 0.0f,}, { 0.0f, 0.0f, 1.0f, 0.0f,}, { 0.0f, 1.0f, 1.0f, 0.0f,}, { 1.0f, 0.0f, 1.0f, 0.0f,}, { 1.0f, 1.0f, 1.0f, 0.0f,}, };
	// Transformation matrices
	ps2_vu0_fvector camera_p = { 0.0f, 0.0f, -300.0f, 0.0f };
	ps2_vu0_fvector camera_zd = { 0.0f, 0.0f, 1.0f, 1.0f };
	ps2_vu0_fvector camera_yd = { 0.0f, 1.0f, 0.0f, 1.0f };
	ps2_vu0_fvector camera_rot = { 0, 0, 0, 0 };
	ps2_vu0_fvector light0 = { 1.0f, 0.0f, 0.3f, 0.0f };
	ps2_vu0_fvector light1 = { 0.0f, 1.0f, 0.3f, 0.0f };
	ps2_vu0_fvector light2 = { 0.0f, 0.0f, 1.0f, 0.0f };
	ps2_vu0_fvector color0 = { 0.4f, 0.4f, 0.4f, 1.0f };
	ps2_vu0_fvector color1 = { 0.4f, 0.4f, 0.4f, 1.0f };
	ps2_vu0_fvector color2 = { 0.4f, 0.4f, 0.4f, 1.0f };
	ps2_vu0_fvector ambient = { 0.2f, 0.2f, 0.2f, 0.0f };
	ps2_vu0_fmatrix local_world;
	ps2_vu0_fmatrix world_view;
	ps2_vu0_fmatrix view_screen;
	ps2_vu0_fmatrix local_screen;
	ps2_vu0_fmatrix normal_light;
	ps2_vu0_fmatrix light_color;
	ps2_vu0_fmatrix local_light;
	ps2_vu0_fmatrix work;
	// those two is all we need to place and rotate the cube
	static ps2_vu0_fvector obj_trans = { 0.0f, 0.0f, 0.0f, 0.0f };
	static ps2_vu0_fvector obj_rot = { 0.0f, 0.0f, 0.0f, 0.0f };
	// Packet to send the cube to VIF1
	vifpacket_t vif_pkt;
	// Packet to send the sprite to the GIF
	gifpacket_t gif_pkt;
	// Primitive type for the cube
	int prim_type = PS2_GS_SETREG_PRIM( PS2_GS_PRIM_PRIM_TRIANGLE, GOURAUD(1), TEXTURED(1), 0, 0, 0, 0, 0, 0 );
	// Screen parameters
	extern ps2_gs_gparam *gparam;
	ps2_gs_gparam *gp;

	gp=gparam;

	// Rotate the cube
	obj_rot[1]+=M_PI/300.0f;
	obj_rot[2]+=M_PI/300.0f;
	// Rotation must be between -PI and PI, otherwise it does wierd things
	if (obj_rot[1]>M_PI) obj_rot[1]-=2.0f*M_PI;
	if (obj_rot[2]>M_PI) obj_rot[2]-=2.0f*M_PI;

	// view -> screen matrix
	ps2_vu0_view_screen_matrix(view_screen, 512.0f, 1.0f, gp->pixel_ratio,
			gp->center_x, gp->center_y, 1.0f, ((1 << 24) - 1), 1.0f, 65536.0f);

	// local -> world (rotate)matrix
	ps2_vu0_unit_matrix(work);
	ps2_vu0_rot_matrix(local_world, work, obj_rot);

	// color&normal matrix setting
	ps2_vu0_normal_light_matrix(normal_light, light0, light1, light2);
	ps2_vu0_light_color_matrix(light_color, color0, color1, color2, ambient);

	// light(normal) -> local_light matrix
	ps2_vu0_mul_matrix(local_light, normal_light, local_world);

	// local -> world (rotate&translate)matrix
	ps2_vu0_trans_matrix(local_world, local_world, obj_trans);

	// world -> view matrix
	vu0_rot_camera_matrix(world_view, camera_p, camera_zd, camera_yd, camera_rot);

	// local -> screen matrix
	ps2_vu0_mul_matrix(work, world_view, local_world);
	ps2_vu0_mul_matrix(local_screen, view_screen, work);


	if (base_ptr==NULL) base_ptr=(u_int *)memalign(16, 16*1024);

	// set base of VIF packet
	vifpacket_init( &vif_pkt, (u_long128*)base_ptr );
	vifpacket_cnt( &vif_pkt, 1<<16 );

	vifpacket_addcode( &vif_pkt, 0x3000000 ); // set vu1 base
	vifpacket_addcode( &vif_pkt, 0x2000200 ); // set vu1 offset

	// local_screen
	vifpacket_openupkcode( &vif_pkt, ( 0 | 0x8000 ), V4_32, 4, 4 );
	vifpacket_addupkdata128N( &vif_pkt, (u_long128*)local_screen, 4 );
	vifpacket_closeupkcode( &vif_pkt );

	// local_world
	vifpacket_openupkcode( &vif_pkt, ( 4 | 0x8000 ), V4_32, 4, 4 );
	vifpacket_addupkdata128N( &vif_pkt, (u_long128*)local_world, 4 );
	vifpacket_closeupkcode( &vif_pkt );

	// light_color
	vifpacket_openupkcode( &vif_pkt, ( 8 | 0x8000 ), V4_32, 4, 4 );
	vifpacket_addupkdata128N( &vif_pkt, (u_long128*)light_color, 4 );
	vifpacket_closeupkcode( &vif_pkt );

	// local_light
	vifpacket_openupkcode( &vif_pkt, ( 12 | 0x8000 ), V4_32, 4, 4 );
	vifpacket_addupkdata128N( &vif_pkt, (u_long128*)local_light, 4 );
	vifpacket_closeupkcode( &vif_pkt );

	// call microprogram
	vifpacket_adddata( &vif_pkt, VIF1_SET_MSCAL(0,0));

	vifpacket_cnt( &vif_pkt, 2<<16 );


	// UNPACK TEX_01 GIF TAG
	vifpacket_openupkcode( &vif_pkt, ( 0 | 0x8000 ), V4_32, 4, 4 );
	vifpacket_addupkdata64( &vif_pkt, PS2_GIFTAG_SET_TOPHALF( 1, EOP(0), PRE(0), 0, PS2_GIFTAG_FLG_PACKED, 2 ) );
	vifpacket_addupkdata64( &vif_pkt, 0xEEL );
	vifpacket_closeupkcode( &vif_pkt );

	// UNPACK TEX_01 DATA
	vifpacket_openupkcode( &vif_pkt, ( 1 | 0x8000 ), V4_32, 4, 4 );
	vifpacket_addupkdata64( &vif_pkt,
			PS2_GS_SETREG_TEX0( game_data.boom.texture.fbp, game_data.boom.texture.fbw,
				game_data.boom.texture.psm, game_data.boom.tw, game_data.boom.th, 1,
				PS2_GS_TEX_TFX_DECAL, game_data.boom.clut.fbp, game_data.boom.clut.psm, 0, 0, 1 ) );
	vifpacket_addupkdata64( &vif_pkt, PS2_GS_TEX0_1 );
	vifpacket_addupkdata64( &vif_pkt, 0);
	vifpacket_addupkdata64( &vif_pkt, PS2_GS_TEXFLUSH );
	vifpacket_closeupkcode( &vif_pkt );

	// UNPACK GIF TAG
	vifpacket_openupkcode( &vif_pkt, ( 3 | 0x8000 ), V4_32, 4, 4 );
	vifpacket_addupkdata64( &vif_pkt, PS2_GIFTAG_SET_TOPHALF( NLOOP, EOP(1), PRE(1), prim_type, PS2_GIFTAG_FLG_PACKED, 3 ) );
	vifpacket_addupkdata64( &vif_pkt, 0x412L );
	vifpacket_closeupkcode( &vif_pkt );

	// UNPACK DATA
	vifpacket_openupkcode( &vif_pkt, ( 4 | 0x8000 ), V4_32, 4, 4 );

	vifpacket_addupkdata128N( &vif_pkt, ( u_long128 * ) vert_data, NLOOP );
	vifpacket_addupkdata128N( &vif_pkt, ( u_long128 * ) norm_data, NLOOP );
	vifpacket_addupkdata128N( &vif_pkt, ( u_long128 * ) color_data, NLOOP );
	vifpacket_addupkdata128N( &vif_pkt, ( u_long128 * ) st_data, NLOOP );

	// close
	vifpacket_closeupkcode( &vif_pkt );

	// wait for current microprogram to finish and start execution of next micro program
	vifpacket_addcode( &vif_pkt, VIF1_SET_MSCNT(0) );

	// set VIF packet quad word size
	vifpacket_end( &vif_pkt, 3<<16 );
	vifpacket_terminate( &vif_pkt );

	{
		extern ps2_vpu *vpu1_handle;
		ps2_dma_start(ps2_vpu_fd(vpu1_handle), NULL, (ps2_dmatag*)vif_pkt.base);
	}

	/*
	{
		unsigned int *dat;
		int i;
		dat=ps2_vpu_data(vpu1_handle);

		for (i=0; i<1024; i++)
		{
			printf("-vudata: 0x%.8x 0x%.8x 0x%.8x 0x%.8x\n", dat[0], dat[1], dat[2], dat[3]);
			dat+=4;
		}
	}
	 */

	
	// setting up a sprite for the background
	{
		struct 
		{
			int r, g, b, a;
			int x0, y0;
			int x1, y1;
			int w;
			int h;
			int x;
			int y;
		} sprite;

		// if memory has not yet been allocated, well, what are we waiting for ?
		if (base_ptr==NULL) base_ptr=(u_int *)memalign(16, 16*1024);

		// full screen
		sprite.x = 0 << 4;
		sprite.y = 0 << 4;
		sprite.w = gparam->width << 4;
		sprite.h = gparam->height << 4;

		// full brightness
		sprite.r = 0x80;
		sprite.g = 0x80;
		sprite.b = 0x80;
		sprite.a = 0x80;

		// tranform to screen coordinate system
		sprite.x0 = (((4096-640)/2)<<4) + sprite.x;
		sprite.y0 = (((4096-480)/2)<<4) + sprite.y;
		sprite.x1 = sprite.x0 + sprite.w;
		sprite.y1 = sprite.y0 + sprite.h;

		// start GIF packet for the sprite
		gifpacket_init(&gif_pkt, (u_long128*)base_ptr);

		// Add GIF tag to setup enviromnent
		gifpacket_addgsdata( &gif_pkt, PS2_GIFTAG_SET_TOPHALF( NLOOP(1), EOP(1), PRE(0), 0, PS2_GIFTAG_FLG_PACKED, NREG(3) ) );
		gifpacket_addgsdata( &gif_pkt, 0xEEEL );

		// Set TEX0 register to use the ps2tux image
		gifpacket_addgsdata( &gif_pkt,
				PS2_GS_SETREG_TEX0( game_data.ps2tux.texture.fbp, game_data.ps2tux.texture.fbw,
					game_data.ps2tux.texture.psm, game_data.ps2tux.tw, game_data.ps2tux.th, 1,
					PS2_GS_TEX_TFX_DECAL, game_data.ps2tux.clut.fbp, game_data.ps2tux.clut.psm, 0, 0, 1 ) );
		gifpacket_addgsdata( &gif_pkt, PS2_GS_TEX0_1 );

		// Set TEX1 to bilinear filtering
		gifpacket_addgsdata( &gif_pkt, PS2_GS_SETREG_TEX1_1( 0, 0, PS2_GS_TEX1_MMAG_LINEAR, PS2_GS_TEX1_MMIN_LINEAR, 0, 0, 0 ) );
		gifpacket_addgsdata( &gif_pkt, PS2_GS_TEX1_1 );

		// Set CLAMP to clamp, not repeat
		gifpacket_addgsdata( &gif_pkt, PS2_GS_SETREG_CLAMP( 1, 1, 0, game_data.ps2tux.texture.w, 0, game_data.ps2tux.texture.h) );
		gifpacket_addgsdata( &gif_pkt, PS2_GS_CLAMP_1 );


		// Add GIF tag to send vertex data
		gifpacket_addgsdata( &gif_pkt, PS2_GIFTAG_SET_TOPHALF( NLOOP(1), EOP(1), PRE(0), 0, PS2_GIFTAG_FLG_REGLIST, NREG(6) ) );
		gifpacket_addgsdata( &gif_pkt, 0x525210L );

		gifpacket_addgsdata( &gif_pkt, PS2_GS_SETREG_PRIM( PS2_GS_PRIM_PRIM_SPRITE, GOURAUD(0), TEXTURED(1), 0, 0, 0, 0, 0, 0 ) );
		gifpacket_addgsdata( &gif_pkt, PS2_GS_SETREG_RGBAQ( sprite.r, sprite.g, sprite.b, sprite.a, FLOAT_ONE ) );
		gifpacket_addgsdata( &gif_pkt, PS2_GS_SETREG_ST( 0, 0 ) );
		gifpacket_addgsdata( &gif_pkt, PS2_GS_SETREG_XYZ( sprite.x0, sprite.y0, 1 ) ); 
		gifpacket_addgsdata( &gif_pkt, PS2_GS_SETREG_ST( FLOAT_ONE, FLOAT_ONE ) );
		gifpacket_addgsdata( &gif_pkt, PS2_GS_SETREG_XYZ( sprite.x1, sprite.y1, 1 ) );

		gifpacket_terminate( &gif_pkt );

		// gifpacket_dump(&gif_pkt);
		// printf("\n");
	}

	{
		extern int fd_gs;
		ps2_dma_start_n(fd_gs, gif_pkt.base, gifpacket_size(&gif_pkt));
	}

	// This is the end of the frame, we send the textures for the next frame.
	ps2_gs_load_image((struct ps2_image*)&game_data.ps2tux.clut);
	ps2_gs_load_image((struct ps2_image*)&game_data.ps2tux.texture);
	ps2_gs_load_image((struct ps2_image*)&game_data.boom.clut);
	ps2_gs_load_image((struct ps2_image*)&game_data.boom.texture);
}

void state_quit()
{
	printf("Quit requested by user\n");
	loop_again=0;
}








